/*
//
// BEGIN SONGBIRD GPL
//
// This file is part of the Songbird web player.
//
// Copyright(c) 2005-2008 POTI, Inc.
// http://songbirdnest.com
//
// This file may be licensed under the terms of of the
// GNU General Public License Version 2 (the "GPL").
//
// Software distributed under the License is distributed
// on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either
// express or implied. See the GPL for the specific language
// governing rights and limitations.
//
// You should have received a copy of the GPL along with this
// program. If not, go to http://www.gnu.org/licenses/gpl.html
// or write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
//
// END SONGBIRD GPL
//
*/

#include "sbPropertyFactory.h"

#include <nsIProperty.h>
#include <nsIVariant.h>
#include <nsStringGlue.h>

#include "sbSimpleProperty.h"

NS_IMPL_THREADSAFE_ISUPPORTS1(sbPropertyFactory, sbIPropertyFactory)

/**
 * See sbIPropertyFactory
 */
NS_IMETHODIMP
sbPropertyFactory::CreateProperty(const nsAString& aID,
                                  const nsAString& aValue,
                                  sbIProperty** _retval)
{
  NS_ENSURE_TRUE(!aID.IsEmpty(), NS_ERROR_INVALID_ARG);

  nsCOMPtr<sbIProperty> property = new sbSimpleProperty(aID, aValue);
  NS_ENSURE_TRUE(property, NS_ERROR_OUT_OF_MEMORY);

  NS_ADDREF(*_retval = property);
  return NS_OK;
}
